#!/bin/bash

echo "SNARK14m Debian/Ubuntu build"
echo "Kevin Rosenberg <kevin@rosenberg.net>"

echo "Install required packages"
sudo apt install build-essential libxerces-c-dev wget
     
echo "Download and patch QT3"
wget https://download.qt.io/archive/qt/3/qt-x11-free-3.3.8b.tar.gz
tar xzf qt-x11-free-3.3.8b.tar.gz
cd qt-x11-free-3.3.8b

# Add missing '#include <stddef.h>' to files using ptrdiff_h
cd include
for i in `grep -l ptrdiff_t *.h`; do
      echo "#include <stddef.h>" > tmp
      cat $i >> tmp
      mv tmp $i
done
cd ..

echo "Build QT3"
echo "yes" | ./configure && make
cd ..

echo "Make shared libraries findable"
sudo mv qt-x11-free-3.3.8b /usr/local/qt3
echo "/usr/local/qt3/lib" > qt3.conf
sudo mv qt3.conf /etc/ld.so.conf.d/.
sudo ldconfig


