/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/blob_table.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#include <cstdio>
#include <cmath>

#include "blkdta.h"
#include "blob.h"
#include "geom.h"
#include "uiod.h"

void Blob_class::table()
{
	INTEGER i;
	REAL dist = 0.0;

	REAL blobisamp;

	Blob.vtable = new REAL[samp];
	Blob.ltable = new REAL[samp + 1]; //for convinience in bwray.cpp when nint=samp, by wei, 1/2005

	blobisamp = (REAL) 1.0 / samp * Blob.support;

	for (i = 0; i < samp; i++)
	{
		Blob.vtable[i] = Blob.radial(dist);
		Blob.ltable[i] = Blob.lintegral(dist);

		dist += blobisamp;
	}

	Blob.ltable[samp] = Blob.ltable[samp - 1]; //the same value for nint=samp and nint=samp-1, by wei, 1/2005

}

