/*
 ***********************************************************
 $SNARK_Header$
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/fom_klds.c $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

// Extracts the weighted squared distance as a fom
#include <assert.h>
#include "malloc.h"
#include "experimenter.h"
#include "read_eval_recon4.h"

/*
 This function reads the weighted squared distance.

 INPUTS:
 itr1 - array of length niters containing the iteration numbers for the first algorithm
 itr2 - array of length niters containing the iteration numbers for the second algorithm
 niters - number of iterations to be read
 keywrd1 - string containing the keyword which defines the first algorithm
 keywrd2 - string containing the keyword which defines the second algorithm

 OUTPUTS:
 wsqd1 - array of length niters containing the weighted squared distance for the first algorithm
 wsqd2 - array of length niters containing the weighted squared distance for the second algorithm
 */
void fom_weighted_squared_distance(int* itr1, int* itr2, int niters,
		char* keywrd1, char* keywrd2, double* wsqd1, double* wsqd2) {
	int i = 0;
	double dummy_for_klds;
	for (i = 0; i < niters; i++) {
		read_eval_recon4(itr1[i], keywrd1, &dummy_for_klds, &wsqd1[i]);
		read_eval_recon4(itr2[i], keywrd2, &dummy_for_klds, &wsqd2[i]);
	}
}
