/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru.h $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef FORU_H
#define FORU_H

#include "alg.h"

class foru_class: public alg_class
{
private:
	void frinit();
	void forwrd();
	void bckwrd(REAL* recon);
	void prjtrn(INTEGER np, REAL* vector, REAL* phi, REAL* dphi);
	void intrpl(REAL ang1, REAL ang2, REAL dang1, REAL dang2, REAL* nold,
			REAL* new1);
	void frfilt(REAL* vector, INTEGER size1, INTEGER nfiltr, REAL cutoff,
			REAL phi);
	void error(INTEGER ktype);
	void ftmap(REAL* vfrom, REAL* vto, BOOLEAN revers);
	void fft(REAL* x, INTEGER* n, INTEGER invdir, REAL fact);
	void ftfill(REAL* recon, REAL* g, INTEGER maxg1);
	void unif(INTEGER icase, REAL ang1, REAL ang2, REAL* nold, REAL* new1);
	void uint1(INTEGER icase, INTEGER ix, INTEGER iy, REAL ang1, REAL ang2,
			REAL* pj1, REAL* pj2);

	void vcase1(REAL ang1, REAL ang2, REAL* pj1, REAL* pj2);
	void vcase2(REAL ang1, REAL ang2, REAL* pj1, REAL* pj2);
	void vcase3(REAL ang1, REAL ang2, REAL* pj1, REAL* pj2);
	void vcase4(REAL ang1, REAL ang2, REAL* pj1, REAL* pj2);
	void vc56(INTEGER icase, REAL ang1, REAL ang2, REAL* pj1, REAL* pj2);

	void vint14(
	REAL* xx,
	REAL* yy,
	REAL xg,
	REAL yg,
	REAL* pj1,
	REAL* pj2,
	INTEGER indmin,
	INTEGER indmax,
	REAL* gr, // changed to pass address. Lajos, Feb 10, 2005
			REAL* gi // changed to pass address. Lajos, Feb 10, 2005
			);

	void store(INTEGER ix, INTEGER iy, REAL gr, REAL gi);

public:
	BOOLEAN Run(REAL* recon, INTEGER* list, REAL* weight, INTEGER iter);

};

#endif // FORU   
