/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/mode.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 SETS THE CONSTRAINT MODE PARAMETERS IN USER COMMON.
 THESE ARE:
 LOFL - LOWER CONSTRAINT FLAG
 LOWER- LOWER CONSTRAINT VALUE
 UPFL - UPPER CONSTRAINT FLAG
 UPPER- UPPER CONSTRAINT VALUE
 */

#include <cstdlib>
#include <cstdio>

#include "blkdta.h"
#include "modefl.h"
#include "uiod.h"

#include "int2str.h"
#include "infile.h"

#include "mode.h"

void mode()
{
	INTEGER word;

	BOOLEAN eol;

	static const INTEGER mode_codes[2] =
	{ CHAR2INT('l', 'o', 'w', 'e'), CHAR2INT('u', 'p', 'p', 'e') };

	Modefl.lofl = FALSE;
	Modefl.upfl = FALSE;

	word = InFile.getwrd(FALSE, &eol, mode_codes, 2);

	while (!eol)
	{
		if (word == mode_codes[0])
		{
			Modefl.lofl = TRUE;
			Modefl.lower = InFile.getnum(FALSE, &eol);

			if (eol)
			{
				fprintf(output, "\n **** value after keyword LOWER can not be found\n **** program aborted\n");
				exit(-1);
			};

		};

		if (word == mode_codes[1])
		{
			Modefl.upfl = TRUE;
			Modefl.upper = InFile.getnum(FALSE, &eol);

			if (eol)
			{
				fprintf(output,
						"\n **** value after keyword UPPER can not be found\n **** program aborted\n");
				exit(-1);
			};
		}

		word = InFile.getwrd(FALSE, &eol, mode_codes, 2);

	}

	//if both flags ('Modefl.lofl' & 'Modefl.upfl') are set to TRUE, but lower
	//constraint ('Modefl.lower') was given a value greater than that given to upper constraint
	//('Modefl.upper'), then output complaint to user and exit execution of snark05 (with exit code 111)
	if (Modefl.lofl && Modefl.upfl)
	{
		if (Modefl.lower > Modefl.upper)
		{
			fprintf(output,
					"\n **** LOWER must not be greater than UPPER\n **** program aborted\n");
			exit(-1);
		}
	}

	if (Modefl.lofl)
	{
		fprintf(output, "\n      lower constraint set to %9.4f", Modefl.lower);
	}

	if (Modefl.upfl)
	{
		fprintf(output, "\n      upper constraint set to %9.4f", Modefl.upper);
	}
}
