/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/objects.h $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef OBJECTS_H
#define OBJECTS_H

#include "blkdta.h"

///////////////////////////////////////////////////////////////////
// THE FIRST 7 ROWS OF 'OBJECT' STORE THE DENSITY FOR THE 7 ENERGY
// LEVELS, 8TH  STORES THE AVERAGE DENSITY;
// 9TH ROW SPECIFIES TYPE OF OBJECT, 1 FOR ELLIPSE/CIRCLE
//                                   2 FOR RECTANGLE/SQUARE
//                                   3 FOR TRIANGLE
//                                   4 FOR SEGMENT OF CIRCLE
//                                   5 FOR SECTOR OF CIRCLE
// 10TH ROW  CX  X-COORDINATE OF CENTER
// 11TH ROW  CY  Y-COORDINATE OF CENTER
// 12TH ROW  U  SEMI X-AXIS LENGTH
// 13TH ROW  V  SEMI Y-AXIS LENGTH
// 14TH ROW  ANG  ANGLE OF ROTATION FROM X-AXIS
// 15TH ROW  SINANG  SIN OF ANGLE OF ROTATION
// 16TH ROW  COSANG  COSINE OF ANGLE OF ROTATION
// 17TH ROW RAYL   LENGTH OF RAY INTERSECTED BY OBJECT
// THIS VALUE OF SUBSCRIPT REFERRED TO IN CREAPR ONLY
enum SNARK_Object_type
{
	SOT_elip, SOT_rect, SOT_tria, SOT_segm, SOT_sect
};

class SNARK_Object
{
public:
	REAL den1[7];   // Densities
	REAL denav;     // Average Dansity
	SNARK_Object_type type;      // Object type
	REAL cx;        // Center X
	REAL cy;        // Center Y
	REAL u;         //
	REAL v;         //
	REAL ang;       //
	REAL sinang;    //
	REAL cosang;    //
	REAL rayl;      //
};

class SNARK_Object_Node
{
public:
	SNARK_Object data;
	SNARK_Object_Node *next;
};

extern int MAX_NUMBER_OF_OBJECTS;
extern SNARK_Object *objects;

#endif
