/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/primfc.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 THIS SUBROUTINE DETERMINES THE PRIMEFACTORIZATION
 OF N I.E.
 N=2**M * IPF(1)*...*IPF(NIPF)
 */

#include <cstdlib>
#include <cstdio>

#include "blkdta.h"
#include "uiod.h"

#include "primfc.h"

void primfc(INTEGER n, INTEGER* m, INTEGER* nipf, INTEGER* ipf, INTEGER mnipf)
{
	INTEGER ns;
	INTEGER n2;
	INTEGER iup;
	INTEGER i;

	// DETERMINE M

	ns = n;
	*m = 0;

	for (;;)
	{
		n2 = ns / 2;
		if ((2 * n2) != ns)
			break;
		ns = n2;
		(*m)++;
	}

	// DETERMINE OTHER PRIME FACTORS

	(*nipf) = 0;
	iup = ns;

	for (i = 3; i <= iup; i += 2)
	{
		if (i > ns)
			return;
		for (;;)
		{
			n2 = ns / i;
			if ((n2 * i) != ns)
				break;
			ns = n2;
			(*nipf)++;
			if (*nipf > mnipf)
			{
				fprintf(output,
						"\n **** the number of prime factors in %d is too large (> %d)",
						n, mnipf);
				fprintf(output, "\n **** program aborted\n");
				exit(1010);
			}
			ipf[*nipf - 1] = i;
		}
	}
	return;
}
