/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/quad_deset.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 SET UP D MATRIX

 COPT = 1 GOITEIN

 COPT = 2 MODIFIED SIRT

 ZERO OUT THE D VECTOR
 */

#include <cstdio>
#include <cmath>

#include "blkdta.h"
#include "geom.h"
#include "consts.h"
#include "uiod.h"
#include "ray.h"
#include "wray.h"
#include "anglst.h"
#include "errfac.h"
#include "blob.h"

#include "quad.h"

void quad_class::deset(REAL* d, INTEGER* list, REAL* weight, BOOLEAN* alg)
{
	INTEGER i;
	INTEGER np;
	INTEGER nr;
	INTEGER numb;
	REAL snorm;
	REAL totwei;
	INTEGER k;
	REAL truval;
	INTEGER j;

	INTEGER area;

	if (Blob.pix_basis)
	{
		area = GeoPar.area;
	}
	else
	{
		area = Blob.area;
	}

	for (i = 0; i < area; i++)
	{
		d[i] = 0.0;
	}

	for (np = 0; np < GeoPar.prjnum; np++)
	{
		for (nr = 0; nr < GeoPar.nrays; nr++)
		{
			if (GeoPar.line)
			{
				if (Blob.pix_basis)
					wray(np, nr, list, weight, &numb, &snorm);
				else
					Blob.bwray(np, nr, list, weight, &numb, &snorm);
			}
			if (GeoPar.strip)
			{
				if (Blob.pix_basis)
					ray(np, nr, list, weight, &numb, &snorm);
				else
					Blob.bray(np, nr, list, weight, &numb, &snorm);
			}
			if (numb != 0)
			{
				if (copt != 1)
				{

					// MODIFIED SIRT

					totwei = 0.0;

					for (k = 0; k < numb; k++)
					{
						totwei += weight[k];
					}

					if ((eopt - 2) >= 0)
					{
						if ((eopt - 2) > 0)
						{
							truval = Anglst.prdta(np, nr);
							error_1 = uerror(np, nr, truval, alg);
						}
						else
						{
							truval = Anglst.prdta(np, nr);
							error_1 = errfac(truval, 0.0, 0.0);
						}
					}
					totwei /= error_1;

					for (k = 0; k < numb; k++)
					{
						j = list[k];
						d[j] += totwei * weight[k];
					}
				}
				else
				{
					// GOITEIN

					if ((eopt - 2) >= 0)
					{
						if ((eopt - 2) > 0)
						{
							truval = Anglst.prdta(np, nr);
							error_1 = uerror(np, nr, truval, alg);
						}
						else
						{
							truval = Anglst.prdta(np, nr);
							error_1 = errfac(truval, 0.0, 0.0);
						}
					}

					for (k = 0; k < numb; k++)
					{
						j = list[k];
						d[j] += (weight[k] * weight[k]) / error_1;
					}
				}

				// NEXT NR
			}
		}

//     NEXT NP

	}

	for (i = 0; i < area; i++)
	{
		if (fabs(d[i]) <= Consts.zero)
		{

			if (Blob.pix_basis || (!Blob.pix_basis && i % 2 == Blob.pr))
			{
				*alg = TRUE;
 				fprintf(output, "\n\n      ***a picture element is missed by all rays, can not compute matrix D, program stops***"); //hstau
				return;
			}
		}

		if (Blob.pix_basis || (!Blob.pix_basis && i % 2 == Blob.pr))
		{
			d[i] = (REAL) 1.0 / d[i];
		}
	}
	return;
}
