/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                                                           *
 *                              S N A R K   1 4                              *
 *                                                                           *
 *                     A PICTURE RECONSTRUCTION PROGRAM                      *
 *                                                                           *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

 transm.cpp,v 1.2 2008/08/25 16:11:09 jklukowska Exp

 SUBROUTINE CALLED BY RTFORT & NOT USEFUL INDEPENDENTLY.
 APPLIES TRANSFORM SYMMETRY RELATIONS
 J1:  INDEX OF REAL PART OF ( I, K ) COEFFICIENT
 J2:  INDEX OF REAL PART OF ( M-I, N-K )   "
*/

#include <cstdio>


#include "blkdta.h"


#include "transm.h"

void transm(REAL* x, INTEGER j1, INTEGER j2, REAL sn, REAL cn)        
{
  REAL aa;
  REAL ab;
  REAL ba;
  REAL bb;
  REAL real;
  REAL amag;

  aa = x[j1] + x[j2];
  ab = x[j1] - x[j2];
  ba = x[j1 + 1] + x[j2 + 1];
  bb = x[j1 + 1] - x[j2 + 1];
  real = cn * ba + sn * ab;
  amag = sn * ba - cn * ab;
  x[j1] = (aa + real) * (REAL) 0.5;
  x[j2] = (aa - real) * (REAL) 0.5;
  x[j1 + 1] = (amag + bb) * (REAL) 0.5;
  x[j2 + 1] = (amag - bb) * (REAL) 0.5;
}        
