/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/wrdpack.cpp $
 $LastChangedRevision: 122 $
 $Date: 2014-07-09 18:18:59 -0400 (Wed, 09 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 wrdpack.cpp,v 1.2 2008/08/25 16:11:09 jklukowska Exp

 THE PURPOSE OF THIS ROUTINE IS TO PACK FOUR CHARACTERS (STORED ONE
 PER WORD STARTING WITH indata(ptr)) INTO A SINGLE WORD word SO THAT
 SIMPLE INTEGER COMPARISONS CAN BE MADE.

 ON RETURN, THE POINTER ptr POINTS TO THE NEXT CHARACTER FOLLOWING THE 
 LAST ONE PACKED.
 IF THE NEXT CHARACTER IS BLANK, THEN wrdpack IS SET TO .true. . IF
 THE NEXT CHARACTER IS NON BLANK, THEN wrdpack IS SET TO .false. 

*/

#include <cstdio>
      
#include "blkdta.h"
#include <ctype.h>  // added by lajos, Nov 18, 2004

#include "wrdpack.h"
      
BOOLEAN wrdpack(CHAR* indata, INTEGER* ptr, INTEGER* word)
{
      
  CHAR list[4];
  CHAR blank = ' ';

  int i;

  for(i = 1; i < 4; i++) 
  {
    list[i] = blank;
  }

  for(i = 0; i < 4; i++) 
  {
    list[i] = tolower(indata[*ptr]);  // changed "tolowr" to "tolower". lajos, Nov 18, 2004
    if(list[i] == blank) break;
    (*ptr)++;
  }
  
  *word = CHAR2INT((*list), *(list+1), *(list+2), *(list+3));

  if(indata[*ptr] == blank) return TRUE;
  return FALSE;
}
