/** @file line_real_t.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef _LINE_REAL_T
#define _LINE_REAL_T

#include "sd_line_t.hpp"

#include <list>

#include <qstring.h>

class QString;
class line_real_set_t;
class line_window_onevar_t;
class line_real_t
{
  typedef std::list<point_real_t> data_real_t;
  data_real_t data;
  QString plotname;
  friend class line_window_onevar_t; // hey, this worked!
  line_real_set_t* mySetP;
  // maybe make 'struct' nodes and trees in historytree.cpp into friendly classes too?
public:
  line_real_t(QString name);

  line_real_t(QString name, int fromX, int toX, double atY); // good for phantom
  bool empty();
  void add(int x, double y);
  void clear();
  int getMinX(); // definitions must wait until the end of line_real_set_t def
  int getMaxX();
  double getMinY();
  double getMaxY();
  QString getName();
  void setset(line_real_set_t* sp);
  void show();
}; // --class line_real_t
#endif
