/** @file picture.h
    @package snark14Input
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef PICTUREWINDOW_H
#define PICTUREWINDOW_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QFrame;
class QLabel;
class QLineEdit;
class QPushButton;
class QRadioButton;

class picturewindow : public QDialog
{ 
    Q_OBJECT

public:
    picturewindow( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~picturewindow();
    QString getOutput();

    QLabel* picturelabel;
    QButtonGroup* picturebuttongroup;
    QRadioButton* reconstructionbutton;
    QRadioButton* testbutton;
    QLineEdit* nelem;
    QLabel* nelemlabel;
    QLineEdit* pixelsize;
    QLabel* pixelsizelabel;
    QFrame* Line10;
    QPushButton* okbutton;
    QPushButton* cancelbutton;
private slots:
      //void activateFields();
    void activateReconstructionFields();
    void deactivateReconstructionFields();
    void checkValues();
};

#endif // PICTUREWINDOW_H
